import math
import random
import itertools
import pyaudio

opzioni = {
	"format": pyaudio.paFloat32,
	"channels": 2,
	"rate": 96000,
	"input": True,
	"frames_per_buffer": 1024
}


class primes:

	def prime(n, k=64):
		"""
		Probabilistic primality test Miller-Rabin.
		Return True if n is probably prime otherwise return False.
		The probability that it is wrong is 2^-2k
		"""
		if n < 2 or n % 2 == 0:
			return False
		if n == 2:
			return True

		r, s = 0, n - 1
		while s % 2 == 0:
			r += 1
			s //= 2

		for i in range(k):
			a = random.randrange(2, n)
			x = pow(a, s, n)
			if x == 1 or x == n - 1:
				continue
			for i in range(r - 1):
				x = pow(x, 2, n)
				if x == n - 1:
					break
			else:
				return False
		return True

	def primes(p, n):
		"""
		Returns the n primes subsequent p.
		[Generator]
		"""
		if p == 2:
			n -= 1
			yield p
		if p % 2 == 0:
			p += 1
		i = 0
		while True:
			if i == n:
				break
			if primes.prime(p):
				i += 1
				yield p
			p += 2


class generator:

	def random(start, stop, n):
		"""
		Returns n random integers in the range [start, end).
		[Generator]
		"""
		audio = pyaudio.PyAudio()
		input = audio.open(**opzioni)
		dati = input.read(
			opzioni["rate"] // opzioni["frames_per_buffer"] * 
			int(math.log(n)) + 500)
		input.close()
		audio.terminate()
		dati = [i for i in dati if i != 0]
		dati = [i for i in dati if i in range(start, stop)]
		random.shuffle(dati)
		for i in range(n):
			yield dati[i]

	def onetimepad(l):
		"""
		Return an l-uple of random integers for a one-time-pad.
		"""
		return tuple(generator.random(0, 2 * 16, l))
